open Items
open CFG

	module I = Interval
	module G = Graph(IntItem)(I)

let f1 a = if I.leq a (I.bot()) then I.bot() 
	   else I.single 0
let f2 a = I.cap a (Some (min_int,41))
let f3 a = I.add a (Some (1,1))
let f4 a = I.cap a (Some (42,max_int))

let edges = [(0, f1, 1); 
	     (1, f2, 2);
	     (2, f3, 1);
	     (1, f4, 3)]

let start = 0
let d0 = I.top()

let result_eq	     = G.SE.T.to_list (G.solve_list_eq edges (start,d0) [3])
let result_widen     = G.SW.T.to_list (G.solve_list_widen edges (start,d0) [3])
let result_con	     = G.SC.T.to_list (G.solve_list edges (start,d0) [3])
let i = ref 0
let _ = Printf.printf "%s\n" 
        (List.fold_left (fun r e -> 
           i:=!i + 1; r^"\n"^(string_of_int !i)^": "
        ) "" result_con)
let result_con_widen = G.SCW.T.to_list (G.solve_list_con_widen edges (start,d0) [3])
