open Items
open Datatypes
open Datalog

module  S = Solve (IntItem)

let prog = [
	Clause (1,[Const 1; Const 2],[]);
	Clause (1,[Const 2; Const 3],[]);
	Clause (2, [Var 1; Var 2], [Query (1, [Var 1; Var 2])]);
	Clause (2, [Var 1; Var 2], [
		Query (1, [Var 1; Var 3]);
		Query (2, [Var 3; Var 2])
		])
	]

let prog0 = [
	Clause (1,[Const 1; Const 2],[]);
	Clause (1,[Const 2; Const 3],[])
	]

let prog1 = [
        Clause (1,[Const 1; Const 2],[]);
        Clause (1,[Const 2; Const 3],[]);
        Clause (2, [Var 1; Var 2], [ Query (1, [Var 1; Var 2])])
]

let solve clause = S.solve clause;
		   S.to_list ()

let solve0 r clause = S.init_clauses clause;
		    S.solve_local r [1] (fun t -> ());
		    S.to_list ()

let answer clause body = S.init_clauses clause;
			 S.answer body
