
type parsed_rhs =
   Sym of string |
   Any_rhs of parsed_rhs list |
   App of string * parsed_rhs list

type parsed_cond =
   Empty_cond |
   Opt of string * string list |
   Excl of string * string list     

type parsed_sym =
   Any_sym |
   Excl_sym of string |
   Expl_sym of string

type parsed_vars = string list
type parsed_pars = string list
type parsed_input = parsed_sym * parsed_vars
type parsed_expr = parsed_sym * parsed_vars * parsed_pars
type parsed_lhs = string * parsed_sym * parsed_vars * parsed_pars
type parsed_rule = 
   string * parsed_sym * parsed_vars * parsed_pars * parsed_rhs * string
type parsed_main =
   string * parsed_sym * parsed_vars * parsed_pars *
   parsed_rhs * parsed_cond * string
