type fun_sym = string
type symbol  = string
type par     = string
type pattern = string list

type head    = fun_sym * symbol * par list
type body    = Out    of string * body list 
             | Fun    of string * pattern * body list
             | Param  of string  
             | Copy

type rule    = head * body
type program = rule list

val to_string : program -> string

