type t
type elt = Sym.t

val empty : t
val mem : elt -> t -> bool
val add : elt -> t -> t
val remove : elt -> t -> t
val iter : (elt -> unit) -> t -> unit
val cardinal : t -> int
val equal : t -> t -> bool
val to_string : t -> string
val print_alphabet : t -> unit
val from_list : elt list -> t
val fold : (elt -> 'a -> 'a) -> t -> 'a -> 'a
