query_list (L)	:-	query (X),
			trans (X,A,L).

query (X) 	:-	query_list (cons(X,_)).

query_list (L)	:-	query_list (cons (X,L)),
			non_empty (X).

non_empty (top).
non_empty (X)	:-	query (X),
			trans (X,A,L),
			non_empty_list (L).

non_empty_list (nil).

non_empty_list (cons (X,L)) 
		:-	query_list (cons (X,L)),
			non_empty (X),
			non_empty_list (L).




			
