val to_graph : ('a,'b,'c) Mtt.mtt -> Mtt.state Graph.t
val used_states : ('a,'b,'c) Mtt.mtt -> Mtt.state list
val used_parameters : ('a,'b,'c) Mtt.mtt -> (Mtt.state,int list) Hashtbl.t
val useful_parameters : ('a,'b,'c) Mtt.mtt -> (Mtt.state * int list) list
val is_non_deterministic : ('a,'b,'c) Mtt.mtt -> bool
val is_linear : ('a,'b,'c) Mtt.mtt -> bool
val is_non_copying : ('a,'b,'c) Mtt.mtt -> bool
val is_copying : ('a,'b,'c) Mtt.mtt -> bool
   (** An mtt is non-copying, if there is at most one occurrence of 
       every context variable in the right-hand side of every rule. *)
val is_weakly_single_use : ('a,'b,'c) Mtt.mtt -> bool
