module IntItem =
   struct
      type t = int
      let eq x y = x == y
   end


module Dummy =
   struct
      type t = int
      let bot = 0
      let lub x y = if x <= y then y else x
      let eq x y = x == y
   end


module W = Solve.Make (IntItem) (Dummy) 

let h (i : IntItem.t) (sigma) =
   if i <= 1 then 1
   else sigma (i-1) + sigma (i-2)

let system (i : IntItem.t) = h i

let result = W.solve system [12]
                
